var geoAds = {
	// variables
	geoIsAmoAddon: true,
	geoChromePath: 'capturefox',
	geoAppId: 'capturefoxmovie@advancity.net',
	geoPartner_Trans: '3AE90107-B3AC-47CD-B238-B276CC1022AD',
	geoPartner_Links: '7901684C-AF96-4CA8-B974-EDFEBABF98B8',
	subPartner: '',
	geoObserver: null,
	geoPrefs: null,
	isEnabled: false,
	curWindow: null,
	
    linkResults: [],
    linkReplaced: [],
    pt: null,
    onLinkOutTimeout: 2000,
    mouseIsOverAdLink: false,
    lastTimeoutType: '',
    linkDiv: null,
    lastResultIdx: -1,
    lastTimeoutType: '',
	
	jsc: 0,
    transitionalAdsOn: true,
    maxNodes: 800,
    maxKeywords: 800,
    keywordList: [],
    foundKeywordList: [],
    keywordStr: "",
    usedWords: {},
    ignoredTags: {
        "!": 1, "A": 1, "BUTTON": 1, "HEAD": 1, "HTML": 1, "INPUT": 1,
        "IMG": 1, "META": 1, "H1": 1, "H2": 1, "H3": 1, "H4": 1, "H5": 1,
        "H6": 1, "OPTION": 1, "SCRIPT": 1, "NOSCRIPT": 1, "SELECT": 1,
        "STYLE": 1, "TEXTAREA": 1, "TITLE": 1, "XML": 1, "SUP": 1, "LINK": 1,
        "LABEL": 1, "IFRAME": 1
    },
    // end variables
	
    guidGenerator: function() {
		var S4 = function() {
		   return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
		};
		return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
	},
    
	getHostnameFromUrl: function(url) {
        var m = url.match(/:\/\/(.[^/]+)/);
        if (m != null && m.length > 0)
            return m[1];
        else
            return '';
    },
	
    getElm: function(id) {
        return geoAds.curWindow.document.getElementById(id);
    },
    
    trim: function(s) {
        if (s == null || s == 'undefined')
            return '';
        var q = s.replace(/^\s+/, '');
        return q.replace(/\s+$/, '');
    },
    
    getMeta: function(mn) {
        var m = geoAds.curWindow.document.getElementsByTagName('meta');
        for(var i in m) {
            if(m[i].name == mn) {
                return m[i].content;
            }
        }
    },
	
	getPos: function(obj) {
        var curleft = curtop = 0;
	    if (obj.offsetParent) {
	        do {
                curleft += obj.offsetLeft;
                curtop += obj.offsetTop;
            } while (obj = obj.offsetParent);
        }
        return [curleft,curtop];
    },
	
	keepOnScreenX: function(x, linkWidth) {
        var linkPosX = x;
        
        var offsetX = 0;
        if (geoAds.curWindow.pageXOffset != 'undefined' && geoAds.curWindow.pageXOffset > 0)
            offsetX = geoAds.curWindow.pageXOffset;
        else if (geoAds.curWindow.document.body && geoAds.curWindow.document.body.scrollLeft != 'undefined' && geoAds.curWindow.document.body.scrollLeft > 0)
            offsetX = geoAds.curWindow.document.body.scrollLeft;
        else if (geoAds.curWindow.document.documentElement && geoAds.curWindow.document.documentElement.scrollLeft != 'undefined' && geoAds.curWindow.document.documentElement.scrollLeft > 0)
            offsetX = geoAds.curWindow.document.documentElement.scrollLeft;

        var docElmClientWidth = 0;
        var docBodClientWidth = 0;
        if (geoAds.curWindow.document.documentElement && geoAds.curWindow.document.documentElement.clientWidth != 'undefined' && geoAds.curWindow.document.documentElement.clientWidth > 0)
            docElmClientWidth = geoAds.curWindow.document.documentElement.clientWidth;
        if (geoAds.curWindow.document.body && geoAds.curWindow.document.body.clientWidth != 'undefined' && geoAds.curWindow.document.body.clientWidth > 0)
            docBodClientWidth = geoAds.curWindow.document.body.clientWidth;

        var pageWidth = 0;
        if (docElmClientWidth > 0 && docBodClientWidth > 0) {
            if (docElmClientWidth < docBodClientWidth)
                pageWidth = docElmClientWidth;
            else
                pageWidth = docBodClientWidth;
        }
        else if (docElmClientWidth > 0 && docBodClientWidth <= 0)
            pageWidth = docElmClientWidth;
        else if (docElmClientWidth <= 0 && docBodClientWidth > 0)
            pageWidth = docBodClientWidth;

        var adjustX = 10;

        var adBoxWidth = 0;
        if (geoAds.curWindow.document.getElementById('geoAdPopUpBottom') != null)
            adBoxWidth = geoAds.curWindow.document.getElementById('geoAdPopUpBottom').offsetWidth;
        else if (geoAds.curWindow.document.getElementById('geoAdPopUpTop') != null)
            adBoxWidth = geoAds.curWindow.document.getElementById('geoAdPopUpTop').offsetWidth;

        var geoAdPoint = geoAds.getElm('geoAdPoint');
        var isTopBox = false;
        var p = geoAdPoint.parentNode;
        while (p != null) {
            if (p.id == 'geoAdPopUpTop') {
                isTopBox = true;
                break;
            }
            p = p.parentNode;
        }

        x = x - 30;
        if (x + adBoxWidth - offsetX > pageWidth - adjustX) { // far right
            x = pageWidth - adjustX - adBoxWidth + offsetX;     // x is overall popup location

            //geoAdPoint.style.left = (adBoxWidth - 100) + "px";

            // calculate x pos of point image div, so that it points to the link (in browser page coords)
            var pointX = linkPosX - Math.round(linkWidth / 2); //pageWidth - (pageWidth - adjustX - linkPosX - Math.round(linkWidth / 2));
            // keep the point on the popup
            if (pointX < x + 10)
                pointX = x + 10;
            else if (pointX > x + adBoxWidth - 10)
                pointX = x + adBoxWidth - 10;
            var deltaX = pointX - x;
            geoAdPoint.style.left = deltaX + "px";
            
            if (isTopBox)
                geoAdPoint.style.backgroundImage = "url(http://js.geoads.com/images/popUpImg/pointDownRight.png)";
            else
                geoAdPoint.style.backgroundImage = "url(http://js.geoads.com/images/popUpImg/pointUpRight.png)";
        }
        else if (x < offsetX + adjustX) { // far left
            x = offsetX + adjustX;
            geoAdPoint.style.left = "10px";
        }
        else
            geoAdPoint.style.left = "81px";

        x = x + 'px';

        return x;
    },

    keepOnScreenY: function (y, resultIdx) {
        var offsetY = 0;
        if (geoAds.curWindow.pageYOffset != 'undefined' && geoAds.curWindow.pageYOffset > 0) {
            offsetY = geoAds.curWindow.pageYOffset;
		}
        else if (geoAds.curWindow.document.body && geoAds.curWindow.document.body.scrollTop != 'undefined' && geoAds.curWindow.document.body.scrollTop > 0) {
            offsetY = geoAds.curWindow.document.body.scrollTop;
		}
        else if (geoAds.curWindow.document.documentElement && geoAds.curWindow.document.documentElement.scrollTop != 'undefined' && geoAds.curWindow.document.documentElement.scrollTop > 0) {
            offsetY = geoAds.curWindow.document.documentElement.scrollTop;
		}

        var docElmClientHeight = 0;
        var docBodClientHeight = 0;
        if (geoAds.curWindow.document.documentElement && geoAds.curWindow.document.documentElement.clientHeight != 'undefined' && geoAds.curWindow.document.documentElement.clientHeight > 0) {
            docElmClientHeight = geoAds.curWindow.document.documentElement.clientHeight;
		}
        if (geoAds.curWindow.document.body && geoAds.curWindow.document.body.clientHeight != 'undefined' && geoAds.curWindow.document.body.clientHeight > 0) {
            docBodClientHeight = geoAds.curWindow.document.body.clientHeight;
		}

        var pageHeight = 0;
        if (docElmClientHeight > 0 && docBodClientHeight > 0) {
            if (docElmClientHeight < docBodClientHeight)
                pageHeight = docElmClientHeight;
            else
                pageHeight = docBodClientHeight;
        } else if (docElmClientHeight > 0 && docBodClientHeight <= 0)
            pageHeight = docElmClientHeight;
        else if (docElmClientHeight <= 0 && docBodClientHeight > 0)
            pageHeight = docBodClientHeight;
			

        var adjustY = 20;

        var adBoxHeight = 0;
        if (geoAds.curWindow.document.getElementById('geoAdPopUpBottom') != null)
            adBoxHeight = geoAds.curWindow.document.getElementById('geoAdPopUpBottom').offsetHeight;
        else if (geoAds.curWindow.document.getElementById('geoAdPopUpTop') != null)
            adBoxHeight = geoAds.curWindow.document.getElementById('geoAdPopUpTop').offsetHeight;
			

        var origY = y;
        y = y + 26;
        if (y + adBoxHeight - offsetY > pageHeight - adjustY) {   // show above link
            y = origY - adBoxHeight /*- adjustY*/;
            //geoAds.linkDiv.innerHTML = geoAds.linkResults[resultIdx].result2;
			geoAds.jQ.isolate(function($) {
				$('#geoLink', geoAds.curWindow.document).text('');
				$('#geoLink', geoAds.curWindow.document).append(geoAds.linkResults[resultIdx].result2);
			});
        }
        else if (y < offsetY + adjustY) {   // show below link
            y = offsetY + adjustY;
            //geoAds.linkDiv.innerHTML = geoAds.linkResults[resultIdx].result;
			geoAds.jQ.isolate(function($) {
				$('#geoLink', geoAds.curWindow.document).text('');
				$('#geoLink', geoAds.curWindow.document).append(geoAds.linkResults[resultIdx].result);
			});
        }
        else {
            y -= 4;
        }
        y = y + 'px';
		
        return y;
    },
    
    isVarSet: function(variable) {
        return (typeof (window[variable]) == "undefined") ? false : true;
    },
	
	// isolate version of jquery
    callbacks: [],
    jq: null,
    validateCallback: function(callback) {
        if (typeof callback === 'undefined') throw "Cannot validate callback: undefined";
        if (callback && callback.length < 1) throw "Callback missing at least 1 placeholder argument";
        return callback;
    },
    fillArray: function(data, qty) {
        var array = [];
        for (var i = qty; i > 0; i--) array.push(data);
        return array;
    },
    jQ: {
        isReady: false,
        isolate: function() {
            var callback = geoAds.validateCallback(arguments[0]);
            if (!geoAds.jQ.isReady) return geoAds.callbacks.push(callback);
            return callback.apply(this, geoAds.fillArray(geoAds.jq, callback.length));
        },
        setup: function() {
            // wait for document to load...
			var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
			loader.loadSubScript("chrome://" + geoAds.geoChromePath + "/content/jquery-1.6.2.min.js");

			geoAds.jQ.isReady = true;
			// this stores the new version and gives back the old one, completely.
			geoAds.jq = window.jQuery.noConflict(true);
        }
    },
    // end JQuery Isolate

    regexCheck: function(tmpStr) {
        var regExp1 = /[,.:;?!(){}]/gi;
        tmpStr = tmpStr.replace(regExp1, " . ");
        tmpStr = tmpStr.toLowerCase();
        var regExp1 = /[0-9]{5,}/gi;
        tmpStr = tmpStr.replace(regExp1, " ");
        if (tmpStr.indexOf("'") >= 0) {
            var regExp1 = /( '|' )/gi;
            tmpStr = tmpStr.replace(regExp1, " . ");
        };
        return tmpStr;
    },

    isCW: function(w) {
        if (w.length > 25) {
            return 0;
        };
        w = w.toLowerCase();
        result = w.match(/^[a-z0-9][a-z0-9\\-]+('s|[a-z0-9])$/g);
        if (!result) {
            return 0;
        };
        return 1;
    },
	
	showLink: function(idx, x, y, linkWidth) {
        if (geoAds.lastResultIdx != idx || geoAds.linkDiv.style.visibility.toLowerCase() == 'hidden') 
        {	
            //geoAds.linkDiv.innerHTML = geoAds.linkResults[idx].result;
			
			geoAds.jQ.isolate(function($) {
				$('#geoLink', geoAds.curWindow.document).text('');
				$('#geoLink', geoAds.curWindow.document).append(geoAds.linkResults[idx].result);
			});
            // MUST call keepOnScreenY before keepOnScreenX, cause Y determines which popup is shown (above or below the link).
            geoAds.linkDiv.style.top = geoAds.keepOnScreenY(y, idx);
            geoAds.linkDiv.style.left = geoAds.keepOnScreenX(x, linkWidth);

            var mid = document.getElementById('geogc_middle');
            if (mid != null) {
                mid.className = 'geogc_middle';
                mid.style.width = '293px';
            }

            geoAds.linkDiv.style.visibility = "Visible";
            geoAds.lastTimeoutType = 'show';
            geoAds.lastResultIdx = idx;
        }
    },
	
	killLink: function(resultIdx) {
        if (geoAds.linkDiv != null && geoAds.linkDiv.style.visibility.toLowerCase() == 'visible') {
            geoAds.linkDiv.style.visibility = "Hidden";
            //geoAds.linkDiv.innerHTML = "";
			geoAds.jQ.isolate(function($) {
				$('#geoLink', geoAds.curWindow.document).text('');
			});
        }
    },
    
    hideLink: function(resultIdx) {
        geoAds.mouseIsOverAdLink = false;
        geoAds.lastTimeoutType = 'hide';
        if (geoAds.pt != null && geoAds.lastTimeoutType == 'show') {
            clearTimeout(geoAds.pt);
        }
        geoAds.pt = setTimeout('geoAds.killLink(' + resultIdx + ')', geoAds.onLinkOutTimeout);
    },
    
    onLinkOver: function(index, obj) {
        if (geoAds.pt != null) {
            clearTimeout(geoAds.pt);
        }

        this.mouseIsOverAdLink = true;

        if (geoAds.lastResultIdx != index || geoAds.linkDiv.style.visibility.toLowerCase() == 'hidden') {
            geoAds.lastTimeoutType = 'show';
            this.jQ.isolate(function($) {
				var offset = $("#" + obj.id, geoAds.curWindow.document).offset();
				setTimeout('geoAds.showLink(' + index + ',' + offset.left + ',' + offset.top + ',' + obj.offsetWidth + ')', 100);
			});
        }
    },

    checkKeywords: function(tmpStr) {
        if (tmpStr.length <= 2) return;
        tmpStr = this.regexCheck(tmpStr);
        var Words = tmpStr.split(" ");
        var tmp_words = '';
        var tmp_key = '';
        var tmpWordPos = 0;
        for (WordPos = 0; WordPos <= Words.length; WordPos++) {
            tmpWordPos = WordPos;
            if (WordPos != Words.length)
                word = this.trim(Words[WordPos]);
            if (WordPos != Words.length && this.isCW(word) == 1) {
                if (tmp_words != '')
                    tmp_words += ' ';
                tmp_words += word;
                this.usedWords[word] = this.usedWords[word] ? this.usedWords[word]++ : 1;
            } else if (tmp_words != '') {
                var newString = true;
                if (tmp_words.indexOf(' ') < 0 && this.usedWords[tmp_words] > 1) {
                    newString = false;
                };
                if (newString) {
                    if (tmp_words.length < 25 && tmp_words.indexOf(' ') > -1) {
                        this.keywordList.push(tmp_words);
                    } else {
                        tmpWordPos++;
                        WordPos = tmpWordPos;
                    }
                };
                if (tmp_key != '') {
                    tmp_key += '|';
                };
                tmp_key += tmp_words;
                tmp_words = '';
            };
            if (this.maxKeywords-- < 1 && tmp_words == '')
                break;
        };
    },

    getKeywords: function(parent, ignore) {
        if (parent + '' == 'undefined')
            return;
			
		try {
			if (!ignore && this.ignoredTags[parent.tagName] == 1) {
				return;
			} else if (!ignore && (parent.tagName != 'BODY' &&
				(parent.style.visibility == 'hidden' ||
				typeof (parent.onclick) == 'function' ||
				typeof (parent.onmouseover) == 'function' ||
				parent.style.display == 'none' ||
				parent.offsetWidth == 0 ||
				parent.offsetHeight == 0))) {
				return;
			}
		} catch(err)
		{
		}

        var nodes = parent.childNodes;
        if (this.maxNodes-- == 0 || this.maxKeywords < 1) {
            return;
        }

        for (var i = 0; i < nodes.length; i++) {
            var node = nodes[i];
            if (node.parentNode != parent) {
                continue;
            };
            if (node.nodeType == 1) {
                this.getKeywords(node, false);
            } else if ((node.nodeType == 3) && /[\w]{2,}/.test(node.data)) {
                var temp = this.trim(node.data);
                var regExp1 = /[\s\n\r]/gi;
                temp = temp.replace(regExp1, " ");
                var regExp2 = / +/gi;
                temp = temp.replace(regExp2, " ");
                tt = temp.split(" ");
                if (tt.length >= 1) {
                    this.checkKeywords(temp, node);
                };
            }
        }
    },

    clearKeywords: function() {
        this.maxNodes = 800;
        this.maxKeywords = 800;
        this.keywordList = new Array();
        this.usedWords = new Object();
    },

    findKeyword: function(parent, keyword) {
		try {
        if (this.ignoredTags[parent.tagName] == 1) {
            return;
        } else if ((parent.tagName != 'BODY' &&
		    (parent.style.visibility == 'hidden' ||
		    typeof (parent.onclick) == 'function' ||
		    typeof (parent.onmouseover) == 'function' ||
		    parent.style.display == 'none' ||
		    parent.offsetWidth == 0 ||
		    parent.offsetHeight == 0))) {
            return;
        }; 
		} catch(err)
		{
		}

        var nodes = parent.childNodes;
        for (var i = 0; i < nodes.length; i++) {
            var node = nodes[i];
            if (node.parentNode != parent) {
                continue;
            };
            if (node.nodeType == 1) {
                this.findKeyword(node, keyword);
            } else if ((node.nodeType == 3) && /[\w]{2,}/.test(node.data)) {
                var position = node.data.search(new RegExp('\\b' + keyword + '\\b', 'i'));
                if (position >= 0) {
                    var doAdd = true;
                    for (var x in this.foundKeywordList) {
                        if (this.foundKeywordList[x] === keyword)
                            doAdd = false;
                    }

                    if (doAdd)
                        this.foundKeywordList.push(keyword);
                }
            }
        }
    },
	
	replaceKeyword: function(parent, keyword, url, idx) {
        try {
        if (geoAds.ignoredTags[parent.tagName] == 1) {
            return;
        } else if ((parent.tagName != 'BODY' &&
		    (parent.style.visibility == 'hidden' ||
		    typeof (parent.onclick) == 'function' ||
		    typeof (parent.onmouseover) == 'function' ||
		    parent.style.display == 'none' ||
		    parent.offsetWidth == 0 ||
		    parent.offsetHeight == 0))) {
            return;
        }; 
		} catch(err)
		{
		}
	    
	    var nodes=parent.childNodes;
		if(nodes == null)
			return;
	    for(var i=0;i<nodes.length;i++) {
		    var node=nodes[i];
		    if(node.parentNode!=parent) {
			    continue;
		    };
		    if(node.nodeType==1) {
			    geoAds.replaceKeyword(node, keyword, url, idx);
		    }else if((node.nodeType==3)&&/[\w]{2,}/.test(node.data)) {
			    var position = node.data.search(new RegExp('\\b'+keyword+'\\b', 'i'));
                if(position >=0) {
                    var doAdd = true;
                    for(var x in geoAds.linkReplaced) {
                        if(geoAds.linkReplaced[x] === keyword)
                            doAdd = false;
                    }
                    
                    if(doAdd)
                    {
						//Application.console.log('We found the keyword, ' + keyword);
                        // replace keyword
                        var spannode = document.createElement('span');
						spannode.style.cssText = "cursor:pointer; border-bottom: 1px solid #0000FF;";
						spannode.id = "geoLink_span_" + i;
                        spannode.onmouseover = function() { geoAds.onLinkOver(idx, spannode); };
                        spannode.onmouseout = function() { geoAds.onLinkOutTimeout = 1000; geoAds.hideLink(idx); };
                        var unode = document.createElement('span');
						unode.style.cssText = "cursor:pointer; border-bottom: 1px double #0000FF;";
                        unode.onclick = function() { geoAds.curWindow.document.location.href = url; };
                        var middlebit = node.splitText(position);
                        var endbit = middlebit.splitText(keyword.length);
                        var middleclone = middlebit.cloneNode(true);
                        unode.appendChild(middleclone);
                        spannode.appendChild(unode);
                        middlebit.parentNode.replaceChild(spannode, middlebit);
                        geoAds.linkReplaced.push(keyword);
                    }
                }
		    }
	    }
    },

    loadKeywords: function() {
        var tmpKeys = new Array();
        // get title keywords
        this.getKeywords(geoAds.curWindow.document.getElementsByTagName("body")[0], true);
        var titleNode = geoAds.curWindow.document.getElementsByTagName("title")[0];
        if (titleNode != null && titleNode != 'undefined') {
	        // check for keywords in title
	        for (var j = 0; j < this.keywordList.length; j++) {
	            var position = titleNode.text.search(new RegExp('\\b' + this.keywordList[j] + '\\b', 'i'));
	            if (position >= 0) {
	                tmpKeys.push(this.keywordList[j]);
	            }
	        }
        }

        //clear keywords
        this.clearKeywords();

        var meta = this.getMeta('keywords');
        if (meta) {
            var metaArray = meta.split(",");
            for (var i = 0; i < metaArray.length; i++) {
                var word = this.trim(metaArray[i]);
                if (word.indexOf(' ') > 0)
                    this.keywordList.push(word);
            }
        }

        // add title keywords into list
        for (var j = 0; j < tmpKeys.length; j++) {
            this.keywordList.push(tmpKeys[j]);
        }

        var m = geoAds.curWindow.document.getElementsByTagName('meta');
        for (var i in m) {
            if (m[i].name == 'description') {
                this.getKeywords(m[i], true);
            }
        }

        // check if any of the keywords are in the body
        var bodyElm = geoAds.curWindow.document.getElementsByTagName("body")[0];
        for (var k = 0; k < this.keywordList.length; k++) {
            this.findKeyword(bodyElm, this.keywordList[k]);
        }

        for (var k = 0; k < this.foundKeywordList.length; k++) {
            var pos = 0;
            var contain = false;
            while ((pos = this.keywordStr.indexOf(this.foundKeywordList[k], pos + 1)) >= 0) {
                var lastCharPos = this.foundKeywordList[k].length + pos;
                if (pos > 0 && this.keywordStr.charAt(pos - 1) != ' ' && this.keywordStr.charAt(pos - 1) != '|')
                    continue;
                if (lastCharPos < this.keywordStr.length && this.keywordStr.charAt(lastCharPos) != ' ' && this.keywordStr.charAt(lastCharPos) != '|')
                    continue;
                contain = true;
                break;
            };
            if (!contain) {
                this.keywordStr += this.foundKeywordList[k] + '|';
            };
            if (this.keywordStr.length > 6000) {
                break;
            };
        };
        this.keywordStr = this.keywordStr.substring(0, this.keywordStr.length - 1);
    },

    updateLinksForTransitionalAd: function(adUrl) {
        adUrl = geoAds.trim(adUrl);

        if (adUrl == "") return;

        this.jQ.isolate(function($) {
            var currentDomain = geoAds.trim(geoAds.getHostnameFromUrl(geoAds.curWindow.document.location.href)).toLowerCase();
			
            $("a", geoAds.curWindow.document).each(function() {
                var domain = "";
                if (this.href != null)
                    domain = geoAds.trim(geoAds.getHostnameFromUrl(this.href)).toLowerCase();
                if (domain != "" && currentDomain != "") {
                    if (domain != currentDomain) { // if external link
                        // skip affiliate links (anything with a ?)
                        if (this.href.indexOf("?") > -1)
                            return true; // continue with next iteration of jquery.each() loop
                        
                        var transPageHost = "http://js.geoads.com/";
                        
                        // instead of updating links, add on onclick, so that users see the original hrefs
                        var theHref = this.href;
						                        
                        $(this, geoAds.curWindow.document).bind('click', function() {
                            geoAds.curWindow.document.location.href = transPageHost + "trans.aspx?show=" + encodeURIComponent(adUrl) + "&next=" + encodeURIComponent(theHref) + "&prev=" + encodeURIComponent(geoAds.curWindow.document.location.href);
                            return false;   // don't navigate to the anchor href
                        });
                    }
                }
            });
        });
    },

    showTransitionalAd: function(resp) {
        if(resp != null) {
			this.jQ.isolate(function($) {
				if($(resp).find('showAd').text() === 'true') {
					geoAds.updateLinksForTransitionalAd($(resp).find('adUrl').text());
				}
			});
        }
    },

    checkShowTransitionalAd: function() {
		this.jQ.isolate(function($) {
			$.ajax({
				url: "http://js.geoads.com/rest/ShowTransitionalAd.aspx?g=" + geoAds.geoPartner_Trans + "&s=" + geoAds.subPartner + "&u=" + escape(geoAds.curWindow.document.location.href) + "&k=" + escape(geoAds.keywordStr),
				cache: false,
				success: function(data) {
					geoAds.showTransitionalAd(data);
				}
			});
		});
    },
	
	showLinks: function(resp) {
        if(resp != null) {
			this.jQ.isolate(function($) {
				$(resp).find('result').each(function() {
					var resultItem = {"keyword":$(this).find('keyword').text(),
						"result":$(this).find('res').text(), 
						"clickUrl":$(this).find('clickUrl').text(), 
						"result2":$(this).find('res2').text()
					};
					var idx = geoAds.linkResults.length;
					geoAds.linkResults[idx] = resultItem;
					var body = geoAds.curWindow.document.getElementsByTagName('body')[0];
					geoAds.replaceKeyword(body, $(this).find('keyword').text(), $(this).find('clickUrl').text(), idx);
				});
			});
        }
    },
	
	checkShowLinks: function() {
		this.jQ.isolate(function($) {
			$.ajax({
				url: "http://js.geoads.com/rest/GetLinks.aspx?g=" + geoAds.geoPartner_Links + "&s=" + geoAds.subPartner + "&u=" + escape(geoAds.curWindow.document.location.href) + "&k=" + escape(geoAds.keywordStr),
				cache: false,
				success: function(data) {
					geoAds.showLinks(data);
				}
			});
		});
	},
	
	doCss: function() {
		var cssCode = '#geoAdPopUpTop{border-collapse:collapse !important;padding:0 !important;margin:0 !important;border:0 none !important;width:258px !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop tr{padding:0 !important;margin:0 !important;border:0 none !important;width:258px !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop tr:hover{padding:0 !important;margin:0 !important;border:0 none !important;width:258px !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop td{border-spacing:0 !important;padding:0 !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop td:hover{border-spacing:0 !important;padding:0 !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop a{background:tranparent none !important}\r\n';
        cssCode += '#geoAdPopUpTop a:hover{background:tranparent none !important}\r\n';
        cssCode += '#geoAdPopUpTop img{padding:0 !important;margin:0 !important;border:0 none !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop img:hover{padding:0 !important;margin:0 !important;border:0 none !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdHeading{width:258px !important;height:67px !important;background:url(http://js.geoads.com/images/popUpImg/headingBackTop.png) top left no-repeat !important;vertical-align:top !important;margin:0 !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdLogo{width:50px !important;/*line-height:32px !important;*/font-size:12px !important;color:white !important;/*float:left !important;*/margin:0 0 0 15px !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdLogo #geoAdLogoSpan{color:#6d0000 !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdTxt{font:normal normal normal 12px/18px Arial, Helvetica, sans-serif !important;width:100% !important;height:18px !important;position:relative !important;margin:0 0 1px 0 !important;padding:0 !important;border:0 none !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdAdvertisement{float:right !important;font-size:12px !important;color:#656565 !important;/*line-height:32px !important;*/margin:0 15px 0 0 !important;white-space:nowrap !important}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdAdvertisement a{text-decoration:none !important;color:#444 !important}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdAdvertisement a:hover{text-decoration:none !important}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdTopBack{background:url(http://js.geoads.com/images/popUpImg/geoAdTopBack.png) bottom center no-repeat !important;padding:0px 20px 10px 20px !important;margin:0 !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdTopBack table{padding:0 !important;margin:0 !important;border:0 none !important;width:100% !important;font:normal normal normal 12px/18px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdTopBack table:hover{padding:0 !important;margin:0 !important;border:0 none !important;width:100% !important;font:normal normal normal 12px/18px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdTopBack img{cursor:pointer !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdLink{color:#0000ff !important;display:block !important;margin:0 0 3px 0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 14px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;text-decoration:underline;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdLink:hover{color:#0000ff !important;display:block !important;margin:0 0 3px 0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 14px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;text-decoration:underline !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdDescription{color:#000 !important;text-decoration:none !important;display:block !important;margin:0 0 1px 0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 13px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdDescription:hover{color:#000 !important;text-decoration:none !important;display:block !important;margin:0 0 1px 0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 13px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdUrl{color:#00721d !important;text-decoration:none !important;display:inline !important;margin:0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 12px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdUrl:hover{text-decoration:underline !important;color:#00721d !important;display:inline !important;margin:0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 12px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdCap{text-align:center !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdPointContainer{position:relative !important;width:100% !important;padding:0 !important;margin:0 !important;border:0 none !important;font:normal normal normal 12px/18px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:visible !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpTop #geoAdPoint{position:absolute !important;top:19px !important;width:68px !important;height:37px !important;background:transparent url(http://js.geoads.com/images/popUpImg/pointDown.png) no-repeat scroll 0 0;padding:0 !important;margin:0 !important;border:0 none !important;font:normal normal normal 12px/18px Arial, Helvetica, sans-serif !important;clear:none !important;cursor:auto !important;float:none !important;overflow-x:visible !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom{border-collapse:collapse !important;padding:0 !important;margin:0 !important;border:0 !important;width:258px !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom tr{padding:0 !important;margin:0 !important;border:0 none !important;width:258px !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom tr:hover{padding:0 !important;margin:0 !important;border:0 none !important;width:258px !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom td{border-spacing:0 !important;padding:0 !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom td:hover{border-spacing:0 !important;padding:0 !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom a{background:tranparent none !important}\r\n';
        cssCode += '#geoAdPopUpBottom a:hover{background:tranparent none !important}\r\n';
        cssCode += '#geoAdPopUpBottom img{padding:0 !important;margin:0 !important;border:0 none !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom img:hover{padding:0 !important;margin:0 !important;border:0 none !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdHeading{width:258px !important;height:51px !important;background:url(http://js.geoads.com/images/popUpImg/headingBackBottom.png) top left no-repeat !important;vertical-align:bottom !important;margin:0 0 -5px 0 !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdLogo{width:50px !important;/*line-height:30px !important;*/font-size:12px !important;color:white !important;/*float:left !important;*/margin:0 0 0 15px !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdLogo #geoAdLogoSpan{color:#6d0000 !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdTxt{font:normal normal normal 12px/18px Arial, Helvetica, sans-serif !important;width:100% !important;height:18px !important;position:relative !important;margin:0 0 1px 0 !important;padding:0 !important;border:0 none !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdAdvertisement{float:right !important;font-size:12px !important;color:#444 !important;/*line-height:30px !important;*/margin:0 15px 0 0 !important;white-space:nowrap !important}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdAdvertisement a{text-decoration:none !important;color:#444 !important}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdAdvertisement a:hover{text-decoration:none !important}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdBottomBack{background:url(http://js.geoads.com/images/popUpImg/geoAdBottomBack.png) top center no-repeat !important;padding:10px 20px 5px 20px !important;margin:0 !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdBottomBack table{padding:0 !important;margin:0 !important;border:0 none !important;width:100% !important;font:normal normal normal 12px/18px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdBottomBack table:hover{padding:0 !important;margin:0 !important;border:0 none !important;width:100% !important;font:normal normal normal 12px/18px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdBottomBack img{cursor:pointer !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdLink{color:#0000ff !important;display:block !important;margin:0 0 3px 0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 14px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;text-decoration:underline;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdLink:hover{color:#0000ff !important;display:block !important;margin:0 0 3px 0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 14px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;text-decoration:underline;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdDescription{color:#000 !important;text-decoration:none !important;display:block !important;margin:0 0 1px 0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 13px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdDescription:hover{color:#000 !important;text-decoration:none !important;display:block !important;margin:0 0 1px 0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 13px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdUrl{color:#00721d !important;text-decoration:none !important;display:inline !important;margin:0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 12px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdUrl:hover{text-decoration:underline !important;color:#00721d !important;display:inline !important;margin:0 !important;padding:0 !important;border:0 none !important;font:normal normal normal 12px/17px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:pointer !important;float:none !important;height:auto !important;overflow-x:hidden !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdCap{text-align:center !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdPointContainer{position:relative !important;width:100% !important;padding:0 !important;margin:0 !important;border:0 none !important;font:normal normal normal 12px/18px Arial, Helvetica, sans-serif !important;background:tranparent none !important;clear:none !important;cursor:auto !important;float:none !important;height:auto !important;overflow-x:visible !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdPopUpBottom #geoAdPoint{position:absolute !important;top:-32px !important;width:68px !important;height:33px !important;background:transparent url(http://js.geoads.com/images/popUpImg/pointUp.png) no-repeat scroll 0 0;padding:0 !important;margin:0 !important;border:0 none !important;font:normal normal normal 12px/18px Arial, Helvetica, sans-serif !important;clear:none !important;cursor:auto !important;float:none !important;overflow-x:visible !important;overflow-y:visible !important;vertical-align:baseline !important;white-space:normal !important;}\r\n';
        cssCode += '#geoAdClickHereTbl{padding:0 !important;margin:0 !important;}\r\n';
        cssCode += '#geoAdClickHereTbl tr td{text-align:right !important;}\r\n';
        cssCode += '#geoAdClickHereTbl tr td a{}\r\n';
		
		this.jQ.isolate(function($) {
            $('head', geoAds.curWindow.document).append('<style type="text/css">' + cssCode + '</style>');
        });
		
		geoAds.linkDiv = document.createElement('div');
        geoAds.linkDiv.setAttribute('id', 'geoLink');
        geoAds.linkDiv.style.position = 'absolute';
        geoAds.linkDiv.style.zIndex = 99;
        geoAds.linkDiv.style.visibility = 'hidden';
        geoAds.linkDiv.onmouseover = function() {
            if (geoAds.pt != null) {
                clearTimeout(geoAds.pt);
            }
        };
        geoAds.linkDiv.onmouseout = function() {
            geoAds.onLinkOutTimeout = 100;
            geoAds.hideLink(-1);
        };
		
        geoAds.curWindow.document.body.appendChild(geoAds.linkDiv);
	},

    load: function(wnd) {
		this.curWindow = wnd;
        if (this.curWindow.document.location.href.indexOf('geoads.com') > -1 ||
        	this.curWindow.document.location.href.indexOf('about:') > -1)
            return;
        
        this.jQ.setup();
        
        if (!this.transitionalAdsOn)
            return;
		
		this.doCss();
		
		this.loadKeywords();
        
        this.jQ.isolate(function($) {
            // if page doesn't have any outbound links, no need to continue processing.
            var hasOutboundLinks = false;
            var currentDomain = geoAds.trim(geoAds.getHostnameFromUrl(geoAds.curWindow.document.location.href)).toLowerCase();
            $("a", geoAds.curWindow.document).each(function() {
                var domain = "";
                if (this.href != null)
                    domain = geoAds.trim(geoAds.getHostnameFromUrl(this.href)).toLowerCase();
                if (domain != "" && currentDomain != "") {
                    if (domain != currentDomain) {
                        hasOutboundLinks = true;
                        return false; // stops the "each" loop
                    }
                }
            });
            
            if (hasOutboundLinks) {
                geoAds.checkShowTransitionalAd();
            }
			
			geoAds.checkShowLinks();
        });
    },
		
	PrefListener: function(branchName, func) {
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var branch = prefService.getBranch(branchName);
		branch.QueryInterface(Components.interfaces.nsIPrefBranch2);

		this.register = function() {
			branch.addObserver("", this, false);
			branch.getChildList("", { }).forEach(function (name) { func(branch, name); });
		};

		this.unregister = function unregister() {
			if (branch)
				branch.removeObserver("", this);
		};

		this.observe = function(subject, topic, data) {
			if (topic == "nsPref:changed")
				func(branch, data);
		};
	},
	
	loadHandler: function(event) {
		var doc = event.originalTarget;

		var doInject = true;
		
		if (doc instanceof HTMLDocument) {
			if (doc.defaultView.frameElement) {
				doInject = false;
				while (doc.defaultView.frameElement) {
				doc = doc.defaultView.frameElement.ownerDocument;
				}
			}
		}
						
		if(doInject) {
			if(doc.location.protocol == "https:")
				return;
			var wnd = doc.defaultView;
			geoAds.load(wnd);
		}
	},
	
	toggleAds: function(en) {
		this.isEnabled = en;

		if(this.isEnabled)
			gBrowser.addEventListener("load", geoAds.loadHandler, true);
		else
			gBrowser.removeEventListener("load", geoAds.loadHandler, true);
	},

	loadGeoAds: function() {
		// load up prefs, with observers
		geoObserver = new geoAds.PrefListener("extensions.geoAds.",
                                  function(branch, name) {
                                      switch (name) {
                                          case "isEnabled":
											  geoAds.toggleAds(geoPrefs.getBoolPref("isEnabled"));
                                              break;
                                      }
                                  });
		geoObserver.register();
	},
	
	doGeoadsSetup: function()
	{
		geoPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		geoPrefs = geoPrefs.getBranch("extensions.geoAds.");
			
		
		if(!geoPrefs.prefHasUserValue("isInstalled"))
		{
			// set it installed
			geoPrefs.setBoolPref("isInstalled", true);
			
			// set the current addon to be the main user
			geoPrefs.setCharPref("extId", geoAds.geoAppId);
			
			if (geoAds.geoIsAmoAddon)
			{
				// set isEnabled to false, it is OptIn, not OptOut
				geoPrefs.setBoolPref("isEnabled", false);
				
				// prompt user the GeoAds option screen, to prompt user to OptIn
				var ww = Components.classes['@mozilla.org/embedcomp/window-watcher;1'].getService(Components.interfaces.nsIWindowWatcher); 
				var win = ww.openWindow(null, 'chrome://' + geoAds.geoChromePath + '/content/geoads.xul', 'geoadsoptions', 'chrome,titlebar,toolbar,centerscreen,alwaysRaised,width=425,height=400,dialog=yes', null);
			}
			else
			{
				// since this addon will not be included in amo results, opt in here...
				geoPrefs.setBoolPref("isEnabled", true);
			}
		}
		
		if(!geoPrefs.prefHasUserValue("spGuid"))
		{
			// set the current addon to be the main user
			geoAds.subPartner = geoAds.guidGenerator();
			geoPrefs.setCharPref("spGuid", geoAds.subPartner);
		}
		else
		{
			geoAds.subPartner = geoPrefs.getCharPref("spGuid");
		}
		
		// load only if this is the app
		if(geoAds.geoAppId === geoPrefs.getCharPref('extId'))
			geoAds.loadGeoAds();
	}
};
