﻿
var url="http://localhost/capturefox/uploadvideo.aspx";
var _videoFile;

window.addEventListener("load", function(e) {  
    _videoFile = window.arguments[0];
}, false); 


function dialog_OnCancel() {
    self.close();
}

function btnStart_OnCommand() {
 	//setParameters();
	//self.close();
	
}

function startUpload() {
    var filePath = _videoFile;
	var username = document.getElementById("txtUsername").value;
	var password = document.getElementById("txtPassword").value;
	var videoTitle = document.getElementById("txtTitle").value;
	var description = document.getElementById("txtDescription").value;
	var keywords = document.getElementById("txtKeywords").value;
	postVideo(filePath, username, password, videoTitle, description, keywords);
}


function postVideo(filePath, username, password, videoTitle, description, keywords) {
    // Make a stream from a file.  
    var bytes = readBinary(filePath);
    if(bytes == null) {
        alert("Video file cannot be read from disk!");
    } else {
        sendData({"username":username, "password":password, "title":videoTitle, "description":description, "keywords":keywords}, filePath, bytes);
    }
}


// progress on transfers from the server to the client (downloads)  
function updateProgress(evt) {  
  if (evt.lengthComputable) {  
    var percentComplete = parseInt(evt.loaded / evt.total * 100);
    document.getElementById("pmPostVideo").value = percentComplete;
  } else {  
    // Unable to compute progress information since the total size is unknown  
  }  
}  
  
function transferComplete(evt) {  
  if(http_request.responseText == "user_not_verified") {
    alert("Your e-mail has not been verified yet. Please check your inbox for the confirmation e-mail.");
  } else if(http_request.responseText == "wrong_credentials") {
    alert("Ooops! Wrong username or password. Please check your username and password.");
  } else {
    alert("Successful! Your video file has been sent and waiting for being processed. We will notify you whenever your video is processed and published.");
  }
  window.close();
}  
  
function transferFailed(evt) {
  alert("An error occurred while transferring the file.");  
}  
  
function transferCanceled(evt) {  
  alert("The transfer has been canceled by the user.");  
}
var http_request;
function sendData(params, filePath, fileBinary) {
    var farr = filePath.split("\\");
    var filename = farr[farr.length-1];
    
    // prepare the MIME POST data
    var boundaryString = 'capturefox';
    var boundary = '--' + boundaryString;
    var requestbody = "";
    
    for(var key in params) {
        requestbody += boundary + '\n' + 'Content-Disposition: form-data; ' + 
        'name="' + key + '"' + '\n' + '\n' + encodeURIComponent(params[key]) + '\n';
    }
    
    requestbody += boundary + '\n' +'Content-Disposition: form-data; name="videofile"; filename="'
        + filename + '"' + '\n'
    + 'Content-Type: application/octet-stream' + '\n'
    + '\n'
    + escape(fileBinary)
    + '\n'
    + boundary;
    
    http_request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]  
                            .createInstance(Components.interfaces.nsIXMLHttpRequest);
    http_request.open('POST', url, false);                        
    http_request.addEventListener("progress", updateProgress, false);  
        http_request.addEventListener("load", transferComplete, false);  
        http_request.addEventListener("error", transferFailed, false);  
        http_request.addEventListener("abort", transferCanceled, false);  
        
    http_request.setRequestHeader("Content-type", "multipart/form-data; \
        boundary=\"" + boundaryString + "\"");
    http_request.setRequestHeader("Connection", "close");
    http_request.setRequestHeader("Content-length", requestbody.length);
    http_request.send(requestbody);

    //document.getElementById('sizespan').innerHTML = "requestbody.length=" + requestbody.length;
    
    // do the AJAX request
    /*
    http_request.onreadystatechange = requestdone;
    http_request.open('POST', url, true);
    http_request.setRequestHeader("Content-type", "multipart/form-data; \
        boundary=\"" + boundaryString + "\"");
    http_request.setRequestHeader("Connection", "close");
    http_request.setRequestHeader("Content-length", requestbody.length);
    http_request.send(requestbody);
    */
}

function readBinary(filePath) {
    var bytes = null;
    var file = Components.classes["@mozilla.org/file/local;1"]
                         .createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(filePath);
    if(file.exists()) {
        var stream = Components.classes["@mozilla.org/network/file-input-stream;1"]  
                               .createInstance(Components.interfaces.nsIFileInputStream);  
        stream.init(file, 0x04 | 0x08, 0644, 0x04); // file is an nsIFile instance     
        //stream.init(file, -1, -1, false);
        var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].
                        createInstance(Components.interfaces.nsIBinaryInputStream);
        bstream.setInputStream(stream);
        var bytes = bstream.readBytes(bstream.available());
        stream.close();
    }
    return bytes;
}